PTYPE  ;	ptype/asm
 	ORG	5200H
 	PUSH	HL
 	LD	HL,HELLO
 	CALL	4467H
 	LD	HL,4411H
 	LD	A,(4)
 	CP	30H
 	JR	Z,HTOP
 	LD	HL,4049H
 HTOP	LD	(TOP1),HL
 	LD	(TOP2),HL
 	LD	(TOP3),HL
 	LD	(TOP4),HL
 	POP	HL
 	LD	DE,4015H
 	LD	A,(DE)
 	AND	2
 	JR	Z,ENTRY
 	LD	HL,NOTOUT
 	CALL	4467H
 	JR	ABORT
 ENTRY	LD	A,(HL)
 	INC	HL		;look to next one
 	CP	13
 	JR	Z,NOTHIN
 	CP	20H
 	JR	Z,ENTRY
 	CP	','
 	JR	Z,ENTRY
 	CP	'!'
 	JR	NZ,NOTALIV
 	LD	A,1
 	LD	(LIVFLAG),A
 	JR	ENTRY
 NOTALIV	CP	'#'
 	JR	NZ,NOTSLOT
 	LD	A,(HL)
 	SUB	30H
 	JR	C,ABORT
 	CP	0AH
 	JR	NC,ABORT
 	LD	(SLOT),A
 	LD	(SLOT1),A
 	INC	HL
 	JR	ENTRY
 NOTSLOT	DEC	HL
 	CALL	VALUE
 	JR	C,ABORT
 	LD	(BUFFSIZE),BC
 	JR	NOTHIN
 ABORT	LD	HL,PARERR
 	CALL	4467H
 	JP	4030H
 NOTHIN
 	LD	HL,TABLE1
 	LD	DE,4641H
 	LD	B,13
 	CALL	COMPARE
 	JR	NZ,BADVER
 	LD	HL,TABLE2
 	LD	DE,4691H
 	LD	B,25
 	CALL	COMPARE
 	JR	NZ,BADVER
 	LD	A,(4635H)
 	CP	80H
 	JR	NZ,BADVER
 	LD	A,0C0H
 	LD	(4635H),A
 	LD	HL,TABLE1N
 	LD	DE,4641H
 	LD	BC,13
 	LDIR
 	LD	HL,TABLE2N
 	LD	DE,4691H
 	LD	BC,25
 	LDIR
 	LD	HL,INSMSG
 	CALL	4467H
 	JR	CONTGO
 BADVER	LD	HL,VERMSG
 	CALL	4467H
 CONTGO	LD	HL,(BUFFSIZE)
 	LD	BC,LAST
 	ADD	HL,BC		;last byte
 	LD	BC,FIRST	;first byte
 	OR	A		;clear carry
 	SBC	HL,BC		;get prgm length
 	LD	B,H
 	LD	C,L		;give to BC
 	LD	HL,(0)
 TOP1	EQU	$-2
 	LD	(TOPMEMO),HL	;old topmem
 	OR	A
 	SBC	HL,BC		;get 
 	PUSH	HL		;save it
 	DEC	HL		;reduce by 1
 	LD	(0),HL
 TOP2	EQU	$-2
 	LD	(TOPMEMN),HL	;save new topmem
 	POP	DE		;get where to move to
 	LD	HL,FIRST	;where drivers are
 	PUSH	BC		;save length
 	PUSH	DE		;save dest
 	PUSH	HL		;save start
 	EX	DE,HL
 	OR	A
 	SBC	HL,DE
 	EX	DE,HL
 	LD	IX,TABLE
 PASSLP	LD	L,(IX)
 	LD	H,(IX+1)
 	LD	A,H
 	OR	L
 	JR	Z,DONEPASS
 	LD	C,(HL)
 	INC	HL
 	LD	B,(HL)
 	EX	DE,HL
 	PUSH	HL
 	ADD	HL,BC
 	LD	B,H
 	LD	C,L
 	POP	HL
 	EX	DE,HL
 	LD	(HL),B
 	DEC	HL
 	LD	(HL),C
 	INC	IX
 	INC	IX
 	JR	PASSLP
 DONEPASS
 	LD	IX,4015H
 	LD	L,(IX+1)
 	LD	H,(IX+2)
 	LD	(CALL),HL
 	LD	HL,INKEY
 	ADD	HL,DE
 	DI
 	LD	(IX+1),L
 	LD	(IX+2),H
 	LD	HL,(INTVEC)
 	ADD	HL,DE
 	LD	(INTVEC),HL
 	LD	HL,(VECTOR)
 	ADD	HL,DE
 	LD	(VECTOR),HL
 	POP	HL
 	POP	DE
 	POP	BC
 	LDIR
 	EI
 	LD	DE,VECTOR
 INTVEC	EQU	$-2
 	LD	A,(4)
 	CP	30H
 	LD	A,10
 SLOT	EQU	$-1
 	JR	Z,DOIII
 	CALL	4410H
 	JR	DOI
 DOIII	CALL	4413H
 DOI	JP	402DH
 COMPARE	LD	A,(DE)
 	CP	(HL)
 	RET	NZ
 	INC	DE
 	INC	HL
 	DJNZ	COMPARE
 	RET
 PARERR	DB	'Parameter Error !',13
 INSMSG	DB	'Disk drivers altered for improved interrupt response.',13
 VERMSG	DB	'Cannot Correct Disk Drivers, Version Has Changed !',13
 NOTOUT	DB	'Cannot Filter OUTPUT Device !',13
 TABLE1	DB	0F3H,0CDH,11H,46H,0DBH,0F0H,0A0H,0E2H,45H,46H,0EDH,0A2H,0FH
 TABLE1N	DB	0CDH,11H,46H,0DBH,0F0H,0A0H,0E2H,44H,46H,0F3H,0EDH,0A2H,0FH
 TABLE2	DB	0E6H,0FCH,28H,20H,05H,28H,12H,0CBH,57H,20H,84H,0CBH,6FH,20H,0AH,0CBH,77H,20H,06H,0CDH,0EAH,45H,0C3H,20H,46H
 TABLE2N	DB	0E6H,0FCH,28H,20H,05H,28H,12H,0CBH,6FH,20H,0EH,0CBH,77H,20H,0AH,0CBH,67H,0C4H,0EAH,45H,0,0,0C3H,20H,46H
 HELLO	DB	1CH,1FH
 	DB	'PTYPE - Dosplus 3.3 Type-Ahead Driver - Version 1.0',10
 	DB	'by Kim Watt - (c)(p) 1982 Breeze/QSD, Inc.',10,10,13
 VALUE	EX	DE,HL
 	LD	BC,ADDHEX
 	LD	(VALCAL1),BC
 	LD	BC,CONVH
 	LD	(VALCAL2),BC
 	LD	A,(DE)
 	CALL	UCASE
 	CP	'H'
 	JR	Z,VALDOIT-1
 	LD	BC,ADDOCT
 	LD	(VALCAL1),BC
 	LD	BC,CONVO
 	LD	(VALCAL2),BC
 	CP	'O'
 	JR	Z,VALDOIT-1
 	LD	BC,ADDBIN
 	LD	(VALCAL1),BC
 	LD	BC,CONVB
 	LD	(VALCAL2),BC
 	CP	'B'
 	JR	Z,VALDOIT-1
 	LD	BC,ADDDEC
 	LD	(VALCAL1),BC
 	LD	BC,CONVD
 	LD	(VALCAL2),BC
 	CP	'D'
 	JR	NZ,VALDOIT
 	INC	DE
 VALDOIT	LD	BC,0
 VALLP	LD	A,(DE)
 	CP	13
 	JR	Z,VALDN+1
 	CP	','
 	JR	Z,VALDN
 	CP	20H
 	JR	Z,VALDN
 	CALL	UCASE
 	CALL	0
 VALCAL2	EQU	$-2
 	RET	C
 	LD	H,B
 	LD	L,C
 	CALL	0
 VALCAL1	EQU	$-2
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	B,H
 	LD	C,L
 	INC	DE
 	JR	VALLP
 VALDN	INC	DE
 	EX	DE,HL
 	RET
 ADDDEC	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,BC
 	ADD	HL,HL
 	RET
 ADDHEX	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,HL
 	RET
 ADDBIN	ADD	HL,HL
 	RET
 ADDOCT	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,HL
 	RET
 CONVD	SUB	30H
 	RET	C
 	CP	10
 	CCF
 	RET
 CONVH	SUB	30H
 	RET	C
 	CP	10
 	CCF
 	RET	NC
 	SUB	7
 	RET	C
 	CP	16
 	CCF
 	RET
 CONVB	SUB	30H
 	RET	C
 	CP	2
 	CCF
 	RET
 CONVO	SUB	30H
 	RET	C
 	CP	8
 	CCF
 	RET
 UCASE	CP	60H
 	RET	C
 	CP	80H
 	RET	NC
 	AND	5FH
 	RET
 TABLE	DW	PASS1
 	DW	PASS2
 	DW	PASS3
 	DW	PASS4
 	DW	PASS5
 	DW	PASS6
 	DW	PASS7
 	DW	PASS8
 	DW	PASS9
 	DW	PASS10
 	DW	PASS11
 	DW	PASS12
 	DW	PASS13
 	DW	PASS14
 	DW	PASS15
 	DW	PASS16
 	DW	PASS17
 	DW	PASS18
 	DW	PASS19
 	DW	PASS20
 	DW	PASS21
 	DW	0
 FIRST	DB	0
 INKEY	DI
 	PUSH	HL
 	LD	HL,0
 KICOUNT	EQU	$-2
 	LD	A,H
 	OR	L
 	POP	HL
 	JR	Z,DONEKEY
 	LD	A,(KEYBUFF)
 PASS1	EQU	$-2
 	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 	LD	HL,KEYBUFF+1
 PASS2	EQU	$-2
 	LD	DE,KEYBUFF
 PASS3	EQU	$-2
 	LD	BC,(BUFFSIZE)
 PASS21	EQU	$-2
 	DEC	BC
 	LDIR
 	POP	BC
 	POP	DE
 	LD	HL,(KICOUNT)
 PASS4	EQU	$-2
 	DEC	HL
 	LD	(KICOUNT),HL
 PASS5	EQU	$-2
 	POP	HL
 DONEKEY	EI
 ;	PUSH	BC
 ;	LD	BC,500H
 ;	PUSH	AF
 ;	CALL	60H
 ;	POP	AF
 ;	POP	BC
 	OR	A
 	RET	Z
 	CP	81H
 	JR	Z,QUIT
 	CP	6
 	JR	Z,TOGGLE
 	CP	0B0H
 	JR	Z,TOGGLE
 	CP	2
 	JP	Z,402DH
 	RET
 VECTOR	DW	DRIVER
 DRIVER	PUSH	AF
 	PUSH	BC
 	PUSH	DE
 	PUSH	HL
 	LD	HL,GET
 PASS6	EQU	$-2
 	PUSH	HL
 	LD	A,0
 LIVFLAG	EQU	$-1
 	OR	A
 	JR	Z,SKPALIV
 	LD	A,(3C3FH)
 	CP	134
 	LD	A,134
 	JR	NZ,PUTALIV
 	LD	A,137
 PUTALIV	LD	(3C3FH),A
 SKPALIV	LD	HL,(KICOUNT)
 PASS7	EQU	$-2
 	LD	BC,80
 BUFFSIZE	EQU	$-2
 	OR	A
 	SBC	HL,BC
 	RET	NC
 	CALL	SCANKEY
 PASS8	EQU	$-2
 	RET	Z
 	LD	BC,(KICOUNT)
 PASS9	EQU	$-2
 	INC	BC
 	LD	(KICOUNT),BC
 PASS10	EQU	$-2
 	LD	HL,KEYBUFF-1
 PASS11	EQU	$-2
 	ADD	HL,BC
 	LD	(HL),A
 	RET
 GET	POP	HL
 	POP	DE
 	POP	BC
 	POP	AF
 	RET
 TOGGLE	DI
 	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 	PUSH	AF
 	EX	AF,AF'
 	PUSH	AF
 	LD	HL,KEYS1
 PASS12	EQU	$-2
 	LD	DE,KEYS2
 PASS13	EQU	$-2
 	LD	B,24
 KEYSWI	LD	A,(HL)
 	EX	AF,AF'
 	LD	A,(DE)
 	LD	(HL),A
 	EX	AF,AF'
 	LD	(DE),A
 	INC	HL
 	INC	DE
 	DJNZ	KEYSWI
 	POP	AF
 	EX	AF,AF'
 	POP	AF
 	POP	BC
 	POP	DE
 	POP	HL
 	XOR	A
 	EI
 	RET
 QUIT	LD	HL,MSG1
 PASS14	EQU	$-2
 	CALL	4467H
 	LD	HL,0
 CALL	EQU	$-2
 	LD	(4016H),HL
 	LD	DE,0
 TOPMEMN	EQU	$-2
 	LD	HL,(0)
 TOP3	EQU	$-2
 	OR	A
 	SBC	HL,DE
 	JR	NZ,DONE
 	LD	HL,0
 TOPMEMO	EQU	$-2		;old topmem pointer
 	LD	(0),HL		;set it up
 TOP4	EQU	$-2
 	LD	HL,RECLAIM
 PASS15	EQU	$-2
 	CALL	4467H
 DONE	LD	A,(4)
 	CP	30H
 	LD	A,10
 SLOT1	EQU	$-1
 	JR	Z,REMIII
 	CALL	4413H
 	JR	REMI
 REMIII	CALL	4416H
 REMI	CALL	2BH
 	JP	402DH
 SCANKEY	LD	HL,MASK
 PASS16	EQU	$-2
 	LD	BC,3801H
 	LD	D,0
 INKEY1	LD	A,(BC)
 	LD	E,A
 	XOR	(HL)
 	LD	(HL),E
 	AND	E
 	JR	NZ,INKEY2
 	INC	D
 	INC	HL
 	RLC	C
 	JP	P,INKEY1
 PASS17	EQU	$-2
 	XOR	A
 	RET
 INKEY2	LD	E,A
 	LD	A,D
 	RLCA
 	RLCA
 	RLCA
 	LD	D,A
 	LD	C,1
 INKEY3	LD	A,C
 	AND	E
 	JR	NZ,INKEY4
 	INC	D
 	RLC	C
 	JR	INKEY3
 INKEY4	LD	C,D
 	LD	B,0
 	LD	HL,KEYS2
 PASS18	EQU	$-2
 	LD	A,(3880H)
 	OR	A
 	JR	NZ,INKEY5
 	LD	HL,KEYS1
 PASS19	EQU	$-2
 INKEY5	ADD	HL,BC
 	LD	A,(HL)
 	CP	4
 	JR	NZ,INKEY6
 	LD	HL,0
 	LD	(KICOUNT),HL
 PASS20	EQU	$-2
 	XOR	A
 	RET
 INKEY6	LD	B,A
 	LD	A,(3840H)
 ;	CP	2
 ;	JR	Z,INKEY7
 	AND	2
 	JR	Z,INKEY7
 	SET	7,B
 INKEY7	LD	A,B
 	OR	A
 	RET
 KEYS1	DB	'@ABCDEFG'
 	DB	'HIJKLMNO'
 	DB	'PQRSTUVW'
 	DB	'XYZ',0,0,0,0,0
 	DB	'01234567'
 	DB	'89:;,-./'
 	DB	13,0,1,5BH,10,8,9,20H
 KEYS2	DB	'`abcdefg'
 	DB	'hijklmno'
 	DB	'pqrstuvw'
 	DB	'xyz',0,0,0,0,0
 	DB	6,'!"#$%&',27H
 	DB	'()*+<=>?'
 	DB	13,5,2,1BH,1AH,18H,19H,143
 MSG1	DB	10,'Cancelled.',3
 RECLAIM	DB	'  Memory Reclaimed.',3
 MASK	DB	0,0,0,0,0,0,0
 LAST	DB	0
 KEYBUFF	EQU	$
 	END	5200H
